﻿--{{{ Libraries

local RL = AceLibrary("Roster-2.1")
local Aura = AceLibrary("SpecialEvents-Aura-2.0")
local L = AceLibrary("AceLocale-2.2"):new("GridStatusHots")

--}}}
--

local hottimer = { }
local playerClass, englishClass = UnitClass("player");
local hotspell=nil
local hotspellduration=nil
local gsh_target=nil
local dbsettings=nil

--{{{ Localization

L:RegisterTranslations("enUS", function()
	return {
		["My HoTs"] = true,
		["Renew"] = true,
		["Rejuvenation"] = true,
		["Regrowth"] = true,
		["Lifebloom"] = true,
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
		["Buff: My Lifebloom"] = true,
		["Set duration"] = true,
		["Set duration of your HoT"] = true,
	}
end)

L:RegisterTranslations("deDE", function()
	return {
		["My HoTs"] = "Meine HoTs",
		["Renew"] = "Erneuerung",
		["Rejuvenation"] = "Verj\195\188ngung",
		["Regrowth"] = "Nachwachsen",
		["Lifebloom"] = "Bl\195\188hendes Leben",
		["Buff: Hot Count"] = "Anzahl Hots",
		["Buff: My Renew"] = "Meine Erneuerung",
		["Buff: My Rejuvenation"] = "Meine Verj\195\188ngung",
		["Buff: My Regrowth"] = "Mein Nachwachsen",
		["Buff: My Lifebloom"] = "Mein Bl\195\188hendes Leben",
		["Set duration"] = "Set Duration",
		["Set duration of your HoT"] = "Set duration of your HoT",
}
end)

L:RegisterTranslations("koKR", function()
	return {
		["My HoTs"] = "자신의 지속 치유",
		["Renew"] = "소생",
		["Rejuvenation"] = "회복",
		["Regrowth"] = "재생",
		["Lifebloom"] = "피어나는 생명",
		["Buff: Hot Count"] = "버프: 지속 치유 갯수",
		["Buff: My Renew"] = "버프 : 자신의 소생",
		["Buff: My Rejuvenation"] = "버프 : 자신의 회복",
		["Buff: My Regrowth"] = "버프 : 자신의 재생",
		["Buff: My Lifebloom"] = "버프: 자신의 피어나는 생명",
		["Set duration"] = "지속시간 설정",
		["Set duration of your HoT"] = "당신의 지속 치유 지속시간을 설정합니다.",
	}
end)

L:RegisterTranslations("frFR", function()
	return {
		["My HoTs"] = "My HoTs", --need translation
		["Renew"] = "R\195\169novation",
		["Rejuvenation"] = "R\195\169cup\195\169ration",
		["Regrowth"] = "R\195\169tablissement",
		["Lifebloom"] = "Lifebloom", -- need translation
		["Buff: Hot Count"] = "Buff: Hot Count", --need translation
		["Buff: My Renew"] = "Buff: My Renew", --need translation
		["Buff: My Rejuvenation"] = "Buff: My Rejuvenation", --need translation
		["Buff: My Regrowth"] = "Buff: My Regrowth", --need translation
		["Buff: My Lifebloom"] = "Buff: My Lifebloom", --need translation
		["Set duration"] = "Set Duration",
		["Set duration of your HoT"] = "Set duration of your HoT",
	}
end)

L:RegisterTranslations("zhCN", function()
	return {
		["My HoTs"] = "我的HoTs",
		["Renew"] = "恢复",
		["Rejuvenation"] = "回春术",
		["Regrowth"] = "癒合",
		["Lifebloom"] = "生命绽放",
		["Buff: Hot Count"] = "Buff: Hot统计",
		["Buff: My Renew"] = "Buff: 我的恢复",
		["Buff: My Rejuvenation"] = "Buff: 我的回春",
		["Buff: My Regrowth"] = "Buff: 我的愈合",
		["Buff: My Lifebloom"] = "Buff: 我的生命绽放",
		["Set duration"] = "设定持续时间",
		["Set duration of your HoT"] = "设定你的Hot的持续时间",
	}
end)

L:RegisterTranslations("zhTW", function()
   return {
      ["My HoTs"] = "我的HoT",
      ["Renew"] = "恢復",
      ["Rejuvenation"] = "回春術",
      ["Regrowth"] = "癒合",
      ["Lifebloom"] = "生命之花",
      ["Buff: Hot Count"] = "Buff: Hot數",
      ["Buff: My Renew"] = "Buff: 我的恢復",
      ["Buff: My Rejuvenation"] = "Buff: 我的回春術",
      ["Buff: My Regrowth"] = "Buff: 我的癒合",
      ["Buff: My Lifebloom"] = "Buff: 我的生命之花",
      ["Set duration"] = "設定持續時間",
      ["Set duration of your HoT"] = "設定你的HoT持續時間",
   }
end)

--}}}

GridStatusHots = GridStatus:NewModule("GridStatusHots")
GridStatusHots.menuName = L["My HoTs"]

--{{{ AceDB defaults
--
GridStatusHots.defaultDB = {
	alert_renew = {
		text = L["Buff: My Renew"],
		desc = L["Buff: My Renew"],
		enable = true,
		priority = 99,
		range = false,
		threshold = 15,
		color = { r = 0, g = 1, b = 0, a = 1 },
	},
	alert_rejuv = {
		text = L["Buff: My Rejuvenation"],
		desc = L["Buff: My Rejuvenation"],
		enable = true,
		priority = 99,
		range = false,
		threshold = 12,
		color = { r = 0, g = 0, b = 1, a = 1 },
	},
	alert_regrow = {
		text = L["Buff: My Regrowth"],
		desc = L["Buff: My Regrowth"],
		enable = true,
		priority = 98,
		range = false,
		threshold = 21,
		color = { r = 1, g = 1, b = 1, a = 1 },
	},
	alert_lifebl = {
		text = L["Buff: My Lifebloom"],
		desc = L["Buff: My Lifebloom"],
		enable = true,
		priority = 99,
		range = false,
		threshold = 7,
		color = { r = 1, g = 0, b = 1, a = 1 },
	},
	alert_tothots = {
		text = L["Buff: Hot Count"],
		desc = L["Buff: Hot Count"],
		enable = true,
		priority = 97,
		range = false,
		color = { r = 0, g = 1, b = 0, a = 1 },
	},
}



--}}}


function GridStatusHots:OnInitialize()
	self.super.OnInitialize(self)

	self:RegisterStatus("alert_tothots", L["Buff: Hot Count"], alert_tothots)
	if englishClass == "PRIEST" then
		self:RegisterStatus("alert_renew", L["Buff: My Renew"], alert_renew)
	end
	if englishClass == "DRUID" then
		self:RegisterStatus("alert_rejuv", L["Buff: My Rejuvenation"], alert_rejuv)
		self:RegisterStatus("alert_regrow", L["Buff: My Regrowth"], alert_regrow)
		self:RegisterStatus("alert_lifebl", L["Buff: My Lifebloom"], alert_lifebl)
	end
end

function GridStatusHots:OnEnable()
	local f = function()
		GridStatusHots:UpdateAll()
	end
	self:ScheduleRepeatingEvent("GHS_Refresh", f,.5)
end

function GridStatusHots:Reset()
	self.super.Reset(self)
end

function GridStatusHots:UpdateAll()
	for u in RL:IterateRoster() do
		local name = UnitName(u.unitid) or ""
		local recnt,rgcnt,rjcnt,lbcnt = 0,0,0,0
		local retime,rjtime,rgtime,lbtime,hcnttxt = nil,nil,nil,nil,nil
		-- Find number of hots pr unit
		for i=1,40 do -- this is not raid numbers, its possible buffs/debuffs to scan per member,
			local bname,brank,btexture,bcount,bdur, btime = UnitBuff(u.unitid, i)
			if not bname then break end
			if bname and bname == L["Renew"] then
				recnt = recnt + 1
				if btime then retime = btime+1 end
			end
			if bname and bname == L["Regrowth"] then 
				rgcnt = rgcnt + 1 
				if btime then rgtime = btime+1 end
			end
			if bname and bname == L["Rejuvenation"] then 
				rjcnt = rjcnt + 1 
				if btime then rjtime = btime+1 end
			end
			if bname and bname == L["Lifebloom"] then
				lbcnt = lbcnt + 1 
				if btime then lbtime = btime+1 end
			end
		end
		-- Set number of hots currently running on all units
		if recnt > 0 or rjcnt > 0 or rgcnt > 0 or lbcnt > 0 then
			hcnttxt = tostring(recnt+rjcnt+rgcnt+lbcnt)
			local settings = self.db.profile.alert_tothots
			self.core:SendStatusGained(name, "alert_tothots",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(hcnttxt)
			)
		else
			if self.core:GetCachedStatus(name, "alert_tothots") then self.core:SendStatusLost(name, "alert_tothots") end
		end

		if retime then 
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_renew
			self.core:SendStatusGained(name, "alert_renew",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(retime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_renew") then self.core:SendStatusLost(name, "alert_renew") end
		end
		if rgtime then 
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_regrow
			self.core:SendStatusGained(name, "alert_regrow",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(rgtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_regrow") then self.core:SendStatusLost(name, "alert_regrow") end
		end
		if rjtime then 
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_rejuv
			self.core:SendStatusGained(name, "alert_rejuv",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(rjtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_rejuv") then self.core:SendStatusLost(name, "alert_rejuv") end
		end
		if lbtime then 
			-- Add self thrown countdown and status
			local settings = self.db.profile.alert_lifebl
			self.core:SendStatusGained(name, "alert_lifebl",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(lbtime).."-"..tostring(hcnttxt))
			)
		else
			if self.core:GetCachedStatus(name, "alert_lifebl") then self.core:SendStatusLost(name, "alert_lifebl") end
		end

	end
end
